\newcommand{\owaspURL}{\url{https://www.owasp.org/images/9/99/
		Helsinki\_meeting\_30\_-
		\_Threats\_and\_Vulnerabilities\_in\_Federation\_Prot
		ocols\_and\_Products.pdf}}
	
\newcommand{\myTable}[4]{
	\resizebox{\textwidth}{!}{
	\begin{tabularx}{\textwidth}{|XX|}
		\hline
		\textbf{Name}&\textbf{#1}\\\hline
		\textbf{Description}&#2\\\hline
		\textbf{Test}&#3\\\hline
	\end{tabularx}}
}

\section{Test Cases}\label{sec:testcases}
After reading the sources described in chapter \ref{sec:sources}, a list of checks that were missing in the tools described in section \ref{sec:toolsassessment} was drafted and it described what our plugin had to focus on.

In this chapter we will discuss in detail of this vulnerabilities, what they mean and in what point of the authentication/authorization flow take place.

In an implementation point of view, some of these checks are missing in our plugin due to the fact that, with having modularity and universality in mind, they were hard to include them in our work. An example can be the correct use of refresh token check, it requires the client ability of reiterating the renew of the access token using the provided refresh token and this obviously differ implementation from implementation, making it impossible for the plugin to be universal. The same idea can be applied to check of the authorization code and access token lifetime given the fact the the information required to be checked are given out in different forms.

The next boxes will describe each test case, focusing on what the check involves and the steps needed to perform it.
\clearpage

\subsection*{URI redirection validation}
\myTable{URI redirection validation}{Redirect URI should be validated, more specifically
	for pointing to internal domains or bypassing
	checks with /../ .}{\begin{enumerate}
		\item{R.O. starts OAuth flow}
		\item{Client redirects R.O. to A.S. with redirect URI}
		\item{Check whether A.S. accepts redirect URIs containing /../ or internal domains}
\end{enumerate}}{\owaspURL}

\subsection*{Tokens stored as plain text in cookies}
\myTable{Tokens stored as plain text in cookies}{Tokens should not be stored as plain text in cookies
	because they would be accessible to attackers in
	browser’s cache.}{\begin{enumerate}
		\item{R.O. starts OAuth flow}
		\item{Client redirects R.O. to A.S. with redirect
			URI}
		\item{R.O. receives authentication code from A.S.}
		\item{R.O. passes authentication token to Client}
		\item{Client exchanges authentication token for
			access token with A.S.}
		\item{Check whether Client stores access token
			as cookie in plain text on R.O.}		
\end{enumerate}}{\owaspURL}

\subsection*{Tokens expiration and lifetime}\label{subsec:tokenexpandlifetime}
\myTable{Tokens expiration and lifetime}{Tokens’ expiration time should be specified and its
	duration should be less than 10 minutes.}{\begin{enumerate}
		\item{R.O receives authorization code}
		\item{Client receives authorization code from R.O.}
		\item{Client exchanges authorization code for access token}
		\item{Check wheter Client can use access token for more than 10 minutes}
\end{enumerate}}{\url{https://tools.ietf.org/html/rfc6819\#section-5.1.5.2}}


\subsection*{Authorization code lifetime}\label{subsec:authcode}
\myTable{Authorization code lifetime}{Authorization code lifetime should be short, usually
	less than 10 minutes.}{\begin{enumerate}
		\item{R.O. receives authorization code}
		\item{Client receives authorization code from
			R.O.}
		\item{Check whether Client can obtain access
			token 10 minutes later than when
			authorization code was issued}
\end{enumerate}}{\url{https://tools.ietf.org/html/rfc6819\#section-5.1.5.2}}

\subsection*{JWT validation}
\myTable{JWT validation}{JWT are used in OpenID for user information and
	authentication session.
	Keys that must be validated: \textit{ iss},\textit{aud},\textit{ id token
		signature},\textit{exp},\textit{iat},\textit{auth\_time}.
	JWT algorithm type need to be checked for “none”
	value}{1\textsuperscript{st} check:\begin{description}\item{\noindent Check every key mentioned when Client receives JWT}\end{description}
	2\textsuperscript{nd} check:\begin{description}
		\item{\noindent Check wheter A.S. accepts JWT with algoritmh type "none" as value}
\end{description}}{\owaspURL}

\subsection*{Correct use of refresh Token}\label{subsec:refreshtoken}
\myTable{Correct use of refresh Token}{A refresh token, coupled with a short access token
	lifetime, can be used to grant longer access to
	resources without involving end-user
	authorization but it should be used only when
	needed.}{\begin{enumerate}
		\item{R.O. starts Oauth flow and obtains
			authorization code and sends it to Client}
		\item{Client obtains access token}
		\item{Check whether Client can repeatedly
			request new access token using refresh
			token even if the one in use is not expired}
\end{enumerate}}{\owaspURL}


\subsection*{Use of HTTP 307 status code}
\myTable{Usage of HTTP 307 status code}{The use of HTTP 307 status code can lead to user’s
	credential leak from the login page.}{Check if any HTTP redirect code is 307}{\owaspURL}

\subsection*{Incorporating external Javascript/components}
\myTable{Incorporating external Javascript/components}{Loading external Javascript or components from
	CDNs can lead to use of malicious code.}{Check for use of external Javascript or components
	in any page}{\owaspURL}

\subsection*{Leaking authorization code through referrer head}
\myTable{Leaking authorization code through referrer head}{Referrer header can be used to obtain code, access
	token or state value. This can be disclosed
	unintentionally by both Clients and A.S.’s web site}{Check for the setting of referrer header in Client’s
	or A.S.’s pages}{\url{https://tools.ietf.org/html/draft-ietf-oauth-
		security-topics-13\#section-4.2}}

\subsection*{Credential / Sensitive data / Secret data disclosure}
\myTable{Credential / Sensitive data / Secret data disclosure}{If the network used for the protocol is not secure,
	data can be disclosed (TLS/SSL needed).}{Check whether any role of the protocol does not use
	TLS or SSL, if so they are susceptible to
	data/credential leakage.}{\url{https://tools.ietf.org/html/draft-ietf-oauth-
		security-topics-13\#section-4.2}}

\newpage